<template>
  <section class="search">
    <section class="search__inputContainer">
      <input class="search__input" type="text" placeholder="Search" v-model="searchQuery" v-on:keyup.enter="onPressEnter" @input="onChange" />
    </section>
  </section>
</template>

<script>
import Vue from 'vue';
import Component from 'vue-class-component';
import debounce from 'lodash.debounce';

@Component()
export default class Search extends Vue {
  searchQuery = '';
  previousQuery = '';
  minCharCounter = 1;

  onChange = debounce(event => {
    const text = event.target.value;
    if (!text) {
      if (this.previousQuery) {
        this.$store.dispatch('clearSearch');
        this.$store.dispatch('closeSearch');
      }
      return;
    }
    if (text === this.previousQuery) {
      return;
    }
    if (text.length <= this.minCharCounter) {
      this.$store.dispatch('clearSearch');
      this.$store.dispatch('closeSearch');
      return;
    }
    this.previousQuery = text;
    this.$store.dispatch('startSearch', text);
    this.$store.dispatch('openSearchResults');
  }, 350);

  onPressEnter() {
    if (!this.searchQuery || this.searchQuery.length < this.minCharCounter) {
      return;
    }
    this.$store.dispatch('startSearch', this.searchQuery);
    this.$store.dispatch('openSearchResults');
  }
}
</script>

<style lang="stylus">
.search
  display flex
  width 50%
  max-width 520px
  height 36px
  border-radius 6px

  &__inputContainer
    width 100%

  &__input
    width 100%
    height 100%
    padding 10px 12px
    border-radius 3px
    border none
    outline none
    background rgba(255,255,255,.04)
    color #fff
    font-weight 500
    font-size 16px
    text-align center
    transition all 350ms ease-in-out
    &::-webkit-input-placeholder
      color rgba(255,255,255,.15)
      font-size 12px
      font-weight bold
      text-transform uppercase
      position relative
      top -2px
    &::-moz-placeholder
      color rgba(255,255,255,.15)
      font-size 12px
      font-weight bold
      text-transform uppercase
      position relative
      top -2px
    &:focus
      background white
      color black
      &::-webkit-input-placeholder
        display none
      &::-moz-placeholder
        display none
</style>